package com.iformall.controller.msg;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.WxMsgConfig;
import com.iformall.service.WxMsgConfigService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("wxMsgConfig")
public class WxMsgConfigController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxMsgConfigService wxMsgConfigService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "短信-配置-列表")
    public ResultData list(@ModelAttribute WxMsgConfig wxMsgConfig, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxMsgConfigController::list");
        if (null == wxMsgConfig) wxMsgConfig = new WxMsgConfig();
        final PageInfo<WxMsgConfig> page = wxMsgConfigService.listAsPage(wxMsgConfig, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "短信-配置-新增")
    public ResultData add(@RequestBody WxMsgConfig wxMsgConfig) {
        logger.debug("[" + getIpAddr() + "] WxMsgConfigController::add");
        //Assert.notNull(wxMsgConfig.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxMsgConfigService.saveOrUpdate(wxMsgConfig);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "短信-配置-更新")
    public ResultData update(@RequestBody WxMsgConfig wxMsgConfig) {
        logger.debug("[" + getIpAddr() + "] WxMsgConfigController::update");
        wxMsgConfigService.saveOrUpdate(wxMsgConfig);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "短信-配置-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMsgConfigController::delete");
        wxMsgConfigService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "短信-配置-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMsgConfigController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxMsgConfigService.getById(id));
    }


}
